package net.mcreator.thenewworld.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.thenewworld.entity.GroatEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class GroatRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(GroatEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelgoat(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("the_new_world:textures/groat.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class Modelgoat extends EntityModel<Entity> {
		private final ModelRenderer left_back_leg;
		private final ModelRenderer right_back_leg;
		private final ModelRenderer right_front_leg;
		private final ModelRenderer left_front_leg;
		private final ModelRenderer body;
		private final ModelRenderer head;
		private final ModelRenderer head_r1;
		public Modelgoat() {
			textureWidth = 64;
			textureHeight = 64;
			left_back_leg = new ModelRenderer(this);
			left_back_leg.setRotationPoint(1.0F, 14.0F, 4.0F);
			left_back_leg.setTextureOffset(36, 29).addBox(0.0F, 4.0F, 0.0F, 3.0F, 6.0F, 3.0F, 0.0F, false);
			right_back_leg = new ModelRenderer(this);
			right_back_leg.setRotationPoint(-3.0F, 14.0F, 4.0F);
			right_back_leg.setTextureOffset(49, 29).addBox(0.0F, 4.0F, 0.0F, 3.0F, 6.0F, 3.0F, 0.0F, false);
			right_front_leg = new ModelRenderer(this);
			right_front_leg.setRotationPoint(-3.0F, 14.0F, -6.0F);
			right_front_leg.setTextureOffset(49, 2).addBox(0.0F, 0.0F, 0.0F, 3.0F, 10.0F, 3.0F, 0.0F, false);
			left_front_leg = new ModelRenderer(this);
			left_front_leg.setRotationPoint(1.0F, 14.0F, -6.0F);
			left_front_leg.setTextureOffset(35, 2).addBox(0.0F, 0.0F, 0.0F, 3.0F, 10.0F, 3.0F, 0.0F, false);
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 24.0F, 0.0F);
			body.setTextureOffset(1, 1).addBox(-4.0F, -17.0F, -7.0F, 9.0F, 11.0F, 16.0F, 0.0F, false);
			body.setTextureOffset(0, 28).addBox(-5.0F, -18.0F, -8.0F, 11.0F, 14.0F, 11.0F, 0.0F, false);
			head = new ModelRenderer(this);
			head.setRotationPoint(1.0F, 14.0F, 0.0F);
			head.setTextureOffset(12, 55).addBox(-2.99F, -16.0F, -10.0F, 2.0F, 7.0F, 2.0F, 0.0F, false);
			head.setTextureOffset(12, 55).addBox(-0.01F, -16.0F, -10.0F, 2.0F, 7.0F, 2.0F, 0.0F, false);
			head.setTextureOffset(2, 61).addBox(2.0F, -11.0F, -10.0F, 3.0F, 2.0F, 1.0F, 0.0F, true);
			head.setTextureOffset(2, 61).addBox(-6.0F, -11.0F, -10.0F, 3.0F, 2.0F, 1.0F, 0.0F, false);
			head.setTextureOffset(23, 52).addBox(-0.5F, -3.0F, -14.0F, 0.0F, 7.0F, 5.0F, 0.0F, false);
			head_r1 = new ModelRenderer(this);
			head_r1.setRotationPoint(0.0F, -8.0F, -8.0F);
			head.addChild(head_r1);
			setRotationAngle(head_r1, 0.9599F, 0.0F, 0.0F);
			head_r1.setTextureOffset(34, 46).addBox(-3.0F, -4.0F, -8.0F, 5.0F, 7.0F, 10.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			left_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			right_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			right_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			left_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			head.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.head.rotateAngleY = f4 / (180F / (float) Math.PI);
			this.right_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.left_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.right_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.left_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}
}
