package net.mcreator.thenewworld.entity.renderer;

import org.apache.logging.log4j.core.Core;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.layers.LayerRenderer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.IEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.IRenderTypeBuffer;

import net.mcreator.thenewworld.entity.SkelebonEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class SkelebonRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(SkelebonEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new ModelSkelebon_M(), 0.5f) {
					{
						this.addLayer(new GlowingLayer<>(this));
					}
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("the_new_world:textures/.png");
					}
				};
			});
		}
	}

	@OnlyIn(Dist.CLIENT)
	private static class GlowingLayer<T extends Entity, M extends EntityModel<T>> extends LayerRenderer<T, M> {
		public GlowingLayer(IEntityRenderer<T, M> er) {
			super(er);
		}

		public void render(MatrixStack matrixStackIn, IRenderTypeBuffer bufferIn, int packedLightIn, T entitylivingbaseIn, float limbSwing,
				float limbSwingAmount, float partialTicks, float ageInTicks, float netHeadYaw, float headPitch) {
			IVertexBuilder ivertexbuilder = bufferIn.getBuffer(RenderType.getEyes(new ResourceLocation("the_new_world:textures/.png")));
			this.getEntityModel().render(matrixStackIn, ivertexbuilder, 15728640, OverlayTexture.NO_OVERLAY, 1, 1, 1, 1);
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class ModelSkelebon_M extends EntityModel<Entity> {
		private final ModelRenderer bone;
		private final ModelRenderer Core;
		public ModelSkelebon_M() {
			textureWidth = 32;
			textureHeight = 32;
			bone = new ModelRenderer(this);
			bone.setRotationPoint(0.0F, 15.0F, 0.0F);
			bone.setTextureOffset(3, 5).addBox(-1.0F, -8.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bone.setTextureOffset(21, 8).addBox(2.0F, -15.0F, 3.0F, 1.0F, 5.0F, 1.0F, 0.0F, false);
			bone.setTextureOffset(21, 0).addBox(-4.0F, -15.0F, 3.0F, 1.0F, 5.0F, 1.0F, 0.0F, false);
			bone.setTextureOffset(0, 8).addBox(-4.0F, -15.0F, -3.0F, 1.0F, 5.0F, 1.0F, 0.0F, false);
			bone.setTextureOffset(0, 0).addBox(2.0F, -15.0F, -3.0F, 1.0F, 5.0F, 1.0F, 0.0F, false);
			bone.setTextureOffset(0, 16).addBox(-3.0F, -9.0F, -2.0F, 5.0F, 1.0F, 5.0F, 0.0F, false);
			bone.setTextureOffset(0, 8).addBox(-4.0F, -10.0F, -3.0F, 7.0F, 1.0F, 7.0F, 0.0F, false);
			bone.setTextureOffset(0, 0).addBox(-4.0F, -16.0F, -3.0F, 7.0F, 1.0F, 7.0F, 0.0F, false);
			Core = new ModelRenderer(this);
			Core.setRotationPoint(-1.0F, 3.0F, 1.0F);
			Core.setTextureOffset(17, 19).addBox(-1.0F, -2.0F, -2.0F, 3.0F, 3.0F, 3.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			bone.render(matrixStack, buffer, packedLight, packedOverlay);
			Core.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bone.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bone.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.Core.rotateAngleX = f2;
		}
	}
}
